diff --git a/libr/core/cmd_type.c b/libr/core/cmd_type.c
index 3b472274faf..cce654fb26c 100644
--- a/libr/core/cmd_type.c
+++ b/libr/core/cmd_type.c
@@ -108,7 +108,15 @@ static void save_parsed_type(RCore *core, const char *parsed) {
 	// First, if this exists, let's remove it.
 	char *type = strdup (parsed);
 	if (type) {
-		char *name = strtok (type, "=");
+		char *name;
+		if ((name = strstr(type, "=type")) || (name = strstr(type, "=struct")) || (name = strstr(type, "=union")) ||
+			(name = strstr(type, "=enum")) || (name = strstr(type, "=func"))) {
+			*name = 0;
+			while (*(name - 1) != '\n') {
+				name--;
+			}
+
+		}
 		if (!name || strchr (name, '\n') || strchr (name, ';')) {
 			/* do nothing */
 		} else {
